//BilderKatalog_312d.js
// 19.07.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Erzeugt einen Bilder-Katalog

//Ein JavaScript fr InDesign CS3, basierend auf dem Script "ImageCatalog.jsx" von Adobe
//bersetzt, optimiert und erweitert von Hans Haesler <hsa@ringier.ch>

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// 'sufString' ist eine globale Variable, enthlt eine Liste von Suffizes
sufString = "|.psd|.tif|.ai|.jpg|.pdf|.eps|.tiff|.png|.gif|";
// den Dialog zur Ordnerauswahl anzeigen 
var selFolder = Folder.selectDialog("Den Ordner whlen, welcher die zu importierenden Bilddateien enthlt");
// den Pfad zum Quellordner bestimmen
if (selFolder != null) {
	// vier Arrays vorbereiten
	var mainList = new Array();
	var foldList = new Array();
	var mainFileList = new Array();
	var subFileList  = new Array();
	var nMain = nSub = 0;

	// die Dateipfade im Hauptordner und die Unterordnerpfade holen
	var fileFold = getMainFiles(selFolder, mainList, foldList);
	
	mainFiles = fileFold[0];
	if (mainFiles.length > 0) {
		// zum Filtern schicken
		mainFileList = fileFilter1(mainFiles);
		nMain = mainFileList.length;
	}
	foldList  = fileFold[1];
	var nFold = foldList.length;
	if (nFold > 0) {
		var subsList = new Array();
		for (n=0; n<nFold; n++) {
			var tmpList = new Array();
			// die Dateipfade in den Unterordnern holen
			subsList = subsList.concat(getSubFiles(foldList[n], tmpList));
		}
		// zum Filtern schicken
		subFileList = fileFilter1(subsList);
		nSub = subFileList.length;
	}
	
	// die Anzahl Dateien (Total, Haupt- und Unterordner)
	var nAll = nMain + nSub;
	
	if (nAll == 0) {
		alert ("Der gewhlte Ordner enthlt keine Bilddateien, welche plaziert werden knnen.");
		exit();
	}
	
	// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
	var defStr = getPrefs();
	// die Werte ausziehen, wenn die Vorgabendatei existiert
	if (defStr != "") {
		var catDef = defStr.split("\n");
		fMan = catDef[0];
		if (fMan == "false") {fMan = false;}
		else {fMan = true;}
		fSub = catDef[1];
		if (fSub == "false") {fSub = false;}
		else {fSub = true;}
		aSiz = catDef[2];
		if (aSiz == "false") {aSiz = false;}
		else {aSiz = true;}
		bSiz = catDef[3];
		if (bSiz == "false") {bSiz = false;}
		else {bSiz = true;}
		cSiz = catDef[4];
		if (cSiz == "false") {cSiz = false;}
		else {cSiz = true;}
		dSiz = catDef[5];
		if (dSiz == "false") {dSiz = false;}
		else {dSiz = true;}
		eSiz = catDef[6];
		if (eSiz == "false") {eSiz = false;}
		else {eSiz = true;}
		pSiz = catDef[7];
		mVal = catDef[8];
		rVal = catDef[9]*1;
		cVal = catDef[10]*1;
		vOff = catDef[11]*1;
		hOff = catDef[12]*1;
		aDir = catDef[13];
		if (aDir == "false") {aDir = false;}
		else {aDir = true;}
		bDir = catDef[14];
		if (bDir == "false") {bDir = false;}
		else {bDir = true;}
		aSor = catDef[15];
		if (aSor == "false") {aSor = false;}
		else {aSor = true;}
		bSor = catDef[16];
		if (bSor == "false") {bSor = false;}
		else {bSor = true;}
		cSor = catDef[17];
		if (cSor == "false") {cSor = false;}
		else {cSor = true;}
		dSor = catDef[18];
		if (dSor == "false") {dSor = false;}
		else {dSor = true;}
		eSor = catDef[19];
		if (eSor == "false") {eSor = false;}
		else {eSor = true;}
		fPrp = catDef[20];
		if (fPrp == "false") {fPrp = false;}
		else {fPrp = true;}
		sPct = catDef[21];
		if (sPct == "false") {sPct = false;}
		else {sPct = true;}
		hPct = catDef[22];
		if (hPct == "false") {hPct = false;}
		else {hPct = true;}
		fFra = catDef[23];
		if (fFra == "false") {fFra = false;}
		else {fFra = true;}
		nNam = catDef[24];
		if (nNam == "false") {nNam = false;}
		else {nNam = true;}
		fNam = catDef[25];
		if (fNam == "false") {fNam = false;}
		else {fNam = true;}
		pNam = catDef[26];
		if (pNam == "false") {pNam = false;}
		else {pNam = true;}
		sInf 
		= catDef[27];
		if (sInf == "false") {sInf = false;}
		else {sInf = true;}
		pInf = catDef[28];
		if (pInf == "false") {pInf = false;}
		else {pInf = true;}
		tSiz = catDef[29]*1;
		jLft = catDef[30];
		if (jLft == "false") {jLft = false;}
		else {jLft = true;}
		jCnt = catDef[31];
		if (jCnt == "false") {jCnt = false;}
		else {jCnt = true;}
		jRgt = catDef[32];
		if (jRgt == "false") {jRgt = false;}
		else {jRgt = true;}
		rEmp = catDef[33];
		if (rEmp == "false") {rEmp = false;}
		else {rEmp = true;}
	}
	else { // wenn keine Vorgabendatei gefunden wurde
		fMan = false;
		fSub = true;
		aSiz = false;
		bSiz = false;
		cSiz = false;
		dSiz = true;
		eSiz = false;
		pSiz = "240 180";
		mVal = "12 8 12 12";
		rVal = 3;
		cVal = 3;
		vOff = 18;
		hOff = 4;
		aDir = true;
		bDir = false;
		aSor = true;
		bSor = false;
		cSor = false;
		dSor = true;
		eSor = false;
		fPrp = false;
		sPct = true;
		hPct = false;
		fFra = false;
		nNam = false;
		fNam = true;
		pNam = false;
		sInf = false;
		pInf = false;
		tSiz = 10;
		jLft = true;
		jCnt = false;
		jRgt = false;
		rEmp = true;
	}
	// die Funktion aufrufen, welche den Dialog vorbereitet, anzeigt und auswertet
	askUser(nMain, nSub, nAll);

	// den Array der Bildpfade erstellen
	if (fMan == true) {
		if (nMain > 0) {
			tmpList = mainFileList;
		}
		else {
			alert ("Der Hauptordner selbst enthlt keine Bilddateien.", "Stop");
			exit();
		}
	}
	else {
		if (nMain > 0 && nSub > 0) {
			tmpList = mainFileList.concat(subFileList);
		}
		else if (nMain > 0 && nSub == 0) {
			tmpList = mainFileList;
		}
		else if (nMain == 0 && nSub > 0) {
			tmpList = subFileList;
		}
	}
	if (aSor) { // alphabetisch sortieren
		if (fMan == true) { // nur Hauptordner
			if (dSor) { // aufsteigend
				defList = tmpList.sort();
			}
			else if (eSor) { // absteigend
				defList = tmpList.sort();
				defList.reverse();
			}
		}
		else { // auch Unterordner
			var namesArr = getNames(tmpList);
			// den Array sortieren
			namesArr.sort(function(a, b) {
				if (dSor) { // aufsteigend
					return a[1] > b[1];
				}
				else if (eSor) { // absteigend
					return a[1] < b[1];
				}
			});
			// dem definitiven Array zuweisen
			defList = namesArr;
		}
	}
	else if (bSor) { // numerisch sortieren
		// die Anzahl Namen
		var nNames = tmpList.length;
		// das Ziffern-RegExp-Objekt
		var num = new RegExp("[0-9]+");
		// prfen, ob der erste Name eine Ziffer enthlt
		var pos = tmpList[0].name.search(num);
		if (pos == -1) {
			alert ("Der erste Name enthlt keine Zahl.", "Stop");
			exit();
		}
		var numbersArr = getNumbers(tmpList, nNames, num);
		// den Array sortieren
		numbersArr.sort(function(a, b) {
			if (dSor) { // aufsteigend
				return a[1] - b[1];
			}
			else if (eSor) { // absteigend
				return b[1] - a[1];
			}
		});
		// dem definitiven Array zuweisen
		defList = numbersArr;
	}
	else if (cSor) { // Erstellungsdatum
		var datesArr = getDates(tmpList);
		// den Array sortieren
		datesArr.sort(function(a, b) {
			if (dSor) { // aufsteigend
				return a[1] - b[1];
			}
			else if (eSor) { // absteigend
				return b[1] - a[1];
			}
		});
		// dem definitiven Array zuweisen
		defList = datesArr;
	}
	// die Funktion zum Erzeugen des Bildkataloges aufrufen
	makeImageCatalog();
}

// die Funktion, welche die Dateien des Hauptordners auflistet (und die Unterordner)
function getMainFiles(selFolder, mainList, foldList) {
	var f = Folder(selFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
			foldList.push(f[i]);
		}
		else {
			mainList.push(f[i]);
		}
	}
	return [mainList, foldList];
}

// die Funktion, welche die Dateien der Unterordner auflistet
function getSubFiles(subFolder, tmpList) {
	var f = Folder(subFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
			getSubFiles(f[i], tmpList);
		}
		else {
			tmpList.push(f[i]);
		}
	}
	return tmpList;
}

// der erste Teil des Datei-Filters
function fileFilter1(subFiles){
	var curFileList = new Array();
	for (var i=0; i<subFiles.length; i++) {
		curFile = subFiles[i];
		if (fileFilter2(curFile)) {
			curFileList.push(curFile);
		}
	}
	return curFileList;
}

// der zweite Teil des Datei-Filters (Windows-Version)

function fileFilter2(curFile){
	var curName = curFile.name.toLowerCase();
	try {
		var curItems = curName.split(".");
		var curSuf = "|." + curItems[(curItems.length)-1] + "|";
		if (sufString.indexOf(curSuf) != -1) {
			return true;
		}
		else {
			return false;
		}
	}
	catch (e) {
		return false;
	}
	return false;
}

// die Funktion, welche die Informationen vorbereitet
function getPrefs() {
	var defStr = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/cat312.txt");
	}
	else {
		var f = new File("~/Library/Preferences/cat312.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// die Funktion, welche den Dialog vorbereitet, anzeigt und auswertet
function askUser(nMain, nSub, nAll) {
	// Dialoge lschen, welche offen geblieben sind
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// den Dialog vorbereiten
	var labelWidth  = 135;
	var labelWidth2 =  94;
//	var textWidth   = 156;
	var textWidth   = 206;
	var aDialog = app.dialogs.add({name:"BilderKatalog"});
	with (aDialog.dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"" + nAll + " Dateien  (Hauptordner = " + nMain + " / Unterordner = " + nSub + ")"});
				}
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Ordnerwahl", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var folButtons = radiobuttonGroups.add();
						with (folButtons) {
							radiobuttonControls.add({staticLabel:"nur Hauptordner", minWidth:textWidth, checkedState:fMan}); //, minWidth:206});
							radiobuttonControls.add({staticLabel:"auch Unterordner", minWidth:textWidth, checkedState:fSub});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Seitenformat", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var sizeButtons = radiobuttonGroups.add();
						with (sizeButtons) {
							radiobuttonControls.add({staticLabel:"DIN A4 hoch", checkedState:aSiz});
							radiobuttonControls.add({staticLabel:"DIN A4 quer", checkedState:bSiz});
							radiobuttonControls.add({staticLabel:"DIN A3 hoch", checkedState:cSiz});
							radiobuttonControls.add({staticLabel:"DIN A3 quer", checkedState:dSiz});
							radiobuttonControls.add({staticLabel:"benutzerdefinierte ...", minWidth:textWidth, checkedState:eSiz});
						}
					}
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Seitenbreite + -hhe", minWidth:labelWidth});
							var pageSizeField = textEditboxes.add({editContents:pSiz, minWidth:84});
							staticTexts.add({staticLabel:"mm"});
						}
					}
				}
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Seitenrnder", minWidth:labelWidth});
							var marginsField = textEditboxes.add({editContents:mVal, minWidth:84});
							staticTexts.add({staticLabel:"mm (y1 y2 x1 x2)"});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl Reihen", minWidth:labelWidth});
					var nRowsField = integerEditboxes.add({editValue:rVal, minWidth:36});
					staticTexts.add({staticLabel:"Abstand Y", minWidth:labelWidth2});
					var verticalOffsetField = realEditboxes.add({editValue:vOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl Kolonnen", minWidth:labelWidth});
					var nColumnsField = integerEditboxes.add({editValue:cVal, minWidth:36});
					staticTexts.add({staticLabel:"Abstand X", minWidth:labelWidth2});
					var horizontalOffsetField = realEditboxes.add({editValue:hOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Anordnung", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var creButtons = radiobuttonGroups.add();
						with (creButtons) {
							radiobuttonControls.add({staticLabel:"von links nach rechts", checkedState:aDir, minWidth:205});
							radiobuttonControls.add({staticLabel:"von oben nach unten", checkedState:bDir});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Sortierung", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var sorButtons = radiobuttonGroups.add();
						with (sorButtons) {
							radiobuttonControls.add({staticLabel:"alphabetisch", checkedState:aSor, minWidth:206});
							radiobuttonControls.add({staticLabel:"numerisch", checkedState:bSor});
							radiobuttonControls.add({staticLabel:"Erstellungsdatum", checkedState:cSor});
						}
					}
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Richtung", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var dirButtons = radiobuttonGroups.add();
						with (dirButtons) {
							radiobuttonControls.add({staticLabel:"aufsteigend", checkedState:dSor});
							radiobuttonControls.add({staticLabel:"absteigend", checkedState:eSor});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Bilder anpassen", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var fitButtons = radiobuttonGroups.add();
						with (fitButtons) {
							radiobuttonControls.add({staticLabel:"proportional", checkedState:fPrp, minWidth:206});
							radiobuttonControls.add({staticLabel:"kleinstmgliches %", checkedState:sPct});
							radiobuttonControls.add({staticLabel:"100%", checkedState:hPct});
							radiobuttonControls.add({staticLabel:"Rahmen an Inhalt", minWidth:textWidth, checkedState:fFra});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Bildlegende", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var labelsButtons = radiobuttonGroups.add();
						with (labelsButtons) {
							radiobuttonControls.add({staticLabel:"keine", checkedState:nNam});
							radiobuttonControls.add({staticLabel:"Dateiname", checkedState:fNam});
							radiobuttonControls.add({staticLabel:"ganzer Pfad", checkedState:pNam});
						}
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Informationen", minWidth:labelWidth});
					with (dialogColumns.add()) {
						var sizeInfo = checkboxControls.add({staticLabel:"Breite mal Hhe (Original)", checkedState:sInf, minWidth:206});
						var ppiInfo  = checkboxControls.add({staticLabel:"ppi (exkl. \".eps\", \".pdf\", \".ai\")", checkedState:pInf});
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Schriftgrad", minWidth:labelWidth});
					var typeSize = realEditboxes.add({editValue:tSiz, minWidth:36});
					staticTexts.add({staticLabel:"pt  "});
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Ausrichtung", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var justButtons = radiobuttonGroups.add();
						with (justButtons) {
							radiobuttonControls.add({staticLabel:"links", checkedState:jLft});
							radiobuttonControls.add({staticLabel:"zentriert", checkedState:jCnt});
							radiobuttonControls.add({staticLabel:"rechts", checkedState:jRgt});
						}
					}
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:" ", minWidth:labelWidth+10});
			var removeEmptyFramesCheckbox = checkboxControls.add({staticLabel:"leere Rahmen entfernen", checkedState:rEmp});
		}
	}
	// den Dialog anzeigen und auswerten
	var dResult = aDialog.show();
	if (dResult == true) {
		// Hauptordner oder auch Unterordner
		var folLabel = folButtons.selectedButton;
		var folBtn = folLabel;
		if (folBtn == 0) {
			fMan = true;
			fSub = false;
		}
		else if (folBtn == 1) {
			fMan = false;
			fSub = true;
		}
		// das Seitenformat
		tmpSiz = pageSizeField.editContents;
		var sizeType = sizeButtons.selectedButton;
		var sBtn = sizeType;
		aSiz = bSiz = cSiz = dSiz = eSiz = false;
		if (sBtn == 0) {
			aSiz = true;
			pW = 210;
			pH = 297;
		}
		else if (sBtn == 1) {
			bSiz = true;
			pW = 297;
			pH = 210;
		}
		else if (sBtn == 2) {
			cSiz = true;
			pW = 297;
			pH = 420;
		}
		else if (sBtn == 3) {
			dSiz = true;
			pW = 420;
			pH = 297;
		}
		else if (sBtn == 4) {
			eSiz = true;
			var tmpSize = tmpSiz.split(" ");
			if (tmpSize.length != 2) {
				alert ("Im benutzerdefinierten Feld bitte zwei Zahlen eintragen.");
				pSiz = tmpSiz;
				aDialog.destroy();
				exit();
			}
			pW = tmpSize[0]*1;
			if (isNaN(pW)) {
				alert ("Ungltiger Wert fr die Seitenbreite.");
				aDialog.destroy();
				exit();
			}
			pH = tmpSize[1]*1;
			if (isNaN(pH)) {
				alert ("Ungltiger Wert fr die Seitenhhe.");
				aDialog.destroy();
				exit();
			}
		}
		pSiz = tmpSiz;
		// die Seitenrnder
		mVal = marginsField.editContents;
		var mVals = mVal.split(" ");
		if (mVals.length == 1) {
			var oneVal = mVal*1;
			if (isNaN(oneVal)) {
				alert ("Ungltiger Wert fr die Rnder.");
				aDialog.destroy();
				exit();
			}
			marY1 = marY2 = marX1 = marX2 = oneVal;
		}
		else if (mVals.length == 4) {
			marY1 = mVals[0]*1;
			if (isNaN(marY1)) {
				alert ("Ungltiger Wert fr den oberen Rand.");
				aDialog.destroy();
				exit();
			}
			marY2 = mVals[1]*1;
			if (isNaN(marY2)) {
				alert ("Ungltiger Wert fr den unteren Rand.");
				aDialog.destroy();
				exit();
			}
			marX1 = mVals[2]*1;
			if (isNaN(marX1)) {
				alert ("Ungltiger Wert fr den linken Rand.");
				aDialog.destroy();
				exit();
			}
			marX2 = mVals[3]*1;
			if (isNaN(marX2)) {
				alert ("Ungltiger Wert fr den rechten Rand.");
				aDialog.destroy();
				exit();
			}
		}
		else {
			alert ("Im Feld fr die Rnder entweder einen oder vier Werte eingeben.");
			aDialog.destroy();
			exit();
		}
		var nRows = nRowsField.editValue;
		rVal = nRows;
		var nColumns = nColumnsField.editValue;
		cVal = nColumns;
		var verticalOffset = verticalOffsetField.editValue;
		vOff = verticalOffset;
		var horizontalOffset = horizontalOffsetField.editValue;
		hOff = horizontalOffset;
		// die Anordnung
		var creType = creButtons.selectedButton;
		var crBtn = creType;
		aDir = bDir = false;
		if (crBtn == 0) {
			aDir = true;
		}
		else if (crBtn == 1) {
			bDir = true;
		}
		// die Sortierung
		var sortType = sorButtons.selectedButton;
		var soBtn = sortType;
		aSor = bSor = cSor = false;
		if (soBtn == 0) {
			aSor = true;
		}
		else if (soBtn == 1) {
			bSor = true;
		}
		else if (soBtn == 2) {
			cSor = true;
		}
		var dirType = dirButtons.selectedButton;
		var diBtn = dirType;
		dSor = eSor = false;
		if (diBtn == 0) {
			dSor = true;
		}
		else if (diBtn == 1) {
			eSor = true;
		}
		// Bilder anpassen
		var fitType = fitButtons.selectedButton;
		var fBtn = fitType;
		fPrp = sPct = hPct = fFra = false;
		if (fBtn == 0) {
			fPrp = true;
		}
		else if (fBtn == 1) {
			sPct = true;
		}
		else if (fBtn == 2) {
			hPct = true;
		}
		else if (fBtn == 3) {
			fFra = true;
		}
		// die Bildlegende
		var selLabel = labelsButtons.selectedButton;
		rBtn = selLabel;
		nNam = fNam = pNam = false;
		if (rBtn == 0) {
			nNam = true;
		}
		else if (rBtn == 1) {
			fNam = true;
		}
		else if (rBtn == 2) {
			pNam = true;
		}
		// die Informationen
		sInf = sizeInfo.checkedState;
		pInf= ppiInfo.checkedState;
		// der Schriftgrad
		tSiz = typeSize.editValue;
		// die Ausrichtung
		var justType = justButtons.selectedButton;
		var jBtn = justType;
		jLft = jCnt = jRgt = false;
		if (jBtn == 0) {
			jLft = true;
			txtJust = Justification.leftAlign;
		}
		else if (jBtn == 1) {
			jCnt = true;
			txtJust = Justification.centerAlign;
		}
		else if (jBtn == 2) {
			jRgt = true;
			txtJust = Justification.rightAlign;
		}
		// leere Rahmen entfernen
		var removeEmptyFrames = removeEmptyFramesCheckbox.checkedState;
		rEmp = removeEmptyFrames;
		aDialog.destroy();
		
		// die Liste der Einstellungen ...
		var prefList = new Array(fMan,fSub,aSiz,bSiz,cSiz,dSiz,eSiz,pSiz,mVal,rVal,cVal,vOff,hOff,aDir,bDir,aSor,bSor,cSor,dSor,eSor,fPrp,sPct,hPct,fFra,nNam,fNam,pNam,sInf,pInf,tSiz,jLft,jCnt,jRgt,rEmp);
		// ... in eine Textkette verwandeln ...
		var curDef = prefList.join("\n");
		// ... zur Funktion schicken, welche sie in eine Datei schreibt
		writeResult(curDef);
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// die Namen feststellen
function getNames(tmpList) {
	namesArr = new Array();
	for (var n=0; n<tmpList.length; n++) {
		var curName = tmpList[n].name;
		namesArr.push([tmpList[n], curName]);
	}
	return namesArr;
}

// die Erzeugungsdaten feststellen
function getDates(tmpList) {
	// ein temporres Dokument und einen Bildrahmen erzeugen
	var tmpDoc = app.documents.add(false);
	var tmpFrm = tmpDoc.rectangles.add();
	datesArr = new Array();
	
	for (var n=0; n<tmpList.length; n++) {
		// das aktuelle Bild laden 
		var curImage = tmpList[n];
		tmpFrm.place(curImage);
		// das Datum feststellen
		try {
			var curTime = (tmpDoc.links[0].linkXmp.creationDate).getTime();
		}
		catch (e) {
			var curTime = (tmpList[n].modified).getTime();
		}
		datesArr.push([tmpList[n], curTime]);
	}
	// das temporre Dokument schliessen
	tmpDoc.close(SaveOptions.no);
	return datesArr;
}

// die Zahlen ausziehen, einen neuen Array bilden
function getNumbers(tmpList, nNames, num) {
	numbersArr = new Array();
	for (var n=0; n<nNames; n++) {
		var numVal = tmpList[n].name.match(num);
		numbersArr.push([tmpList[n], numVal]);
	}
	return numbersArr;
}

// das Ergebnis in eine Datei schreiben
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/cat312.txt");
	}
	else {
		var f = File("~/Library/Preferences/cat312.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die Funktion, welche das Dokument und die Rahmen erzeugt, 
// die Bilder importiert und bei Bedarf die Bildlegenden einsetzt
function makeImageCatalog(){
	var curPage, curFile, x1, y1, x2, y2, curRect, labelStyle, labelLayer;
	var framesPerPage = rVal * cVal;
	var marginPrefs = app.marginPreferences;
	var oldY1 = marginPrefs.top;
	var oldX1 = marginPrefs.left;
	var oldY2 = marginPrefs.bottom;
	var oldX2 = marginPrefs.right;
	marginPrefs.top = marY1;
	marginPrefs.left = marX1;
	marginPrefs.bottom = marY2;
	marginPrefs.right = marX2;
	var curDoc = app.documents.add();
	app.marginPreferences.top = oldY1;
	app.marginPreferences.left = oldX1;
	app.marginPreferences.bottom = oldY2;
	app.marginPreferences.right = oldX2;
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	var docPrefs = curDoc.documentPreferences;
	var nFrames = defList.length;
	var nPages = Math.round(nFrames / framesPerPage);
	if ((nPages*framesPerPage) < nFrames) {
		nPages++;
	}
	docPrefs.pageWidth = pW;
	docPrefs.pageHeight = pH;
	docPrefs.pagesPerDocument = nPages;
	docPrefs.facingPages = false;
	var liveWidth = (pW - ((marX1) + (marX2))) + hOff;
	var liveHeight = pH - ((marY1) + (marY2));
	var columnWidth = liveWidth / cVal;
	var frameWidth = columnWidth - hOff;
	var rowHeight = (liveHeight / rVal);
	var frameHeight = rowHeight - vOff;
	var allPages = curDoc.pages;
	if (rBtn > 0){
		// das Absatzformat "Bildlegende" erzeugen
		labelStyle = curDoc.paragraphStyles.item("Bildlegende");
		try {
			labelStyle.name;
		}
		catch (e) {
			labelStyle = curDoc.paragraphStyles.add({name:"Bildlegende"});
		}
		labelStyle.pointSize = tSiz;
		labelStyle.justification = txtJust;
		// die Ebene "Bildlegenden" erzeugen
		var labelLayer = curDoc.layers.item("Bildlegenden");
		try {
			labelLayer.name;
		}
		catch (e){
			labelLayer = curDoc.layers.add({name:"Bildlegenden"});
		}
	}
	// die Rahmen rckwrts aufbauen
	var curPage;
	var noColor = curDoc.swatches.itemByName("None");
	for (p = curDoc.pages.length-1; p>=0; p--) {
		curPage = allPages.item(p); 
		if (aDir == true) {
			for (var j=rVal; j>=1; j--) {
				y1 = marY1+(rowHeight*(j-1));
				y2 = y1+frameHeight;
				for (var k=cVal; k>=1; k--) {
					x1 = marX1+(columnWidth*(k-1));
					x2 = x1+frameWidth;
					curPage.rectangles.add(curDoc.layers.item(-1), undefined, undefined, {geometricBounds:[y1, x1, y2, x2], strokeWeight:0, strokeColor:noColor});
				}
			}
		}
		else {
			for (var k=cVal; k>=1; k--) {
				x1 = marX1+(columnWidth*(k-1));
				x2 = x1+frameWidth;
				for (var j=rVal; j>=1; j--) {
					y1 = marY1+(rowHeight*(j-1));
					y2 = y1+frameHeight;
					curPage.rectangles.add(curDoc.layers.item(-1), undefined, undefined, {geometricBounds:[y1, x1, y2, x2], strokeWeight:0, strokeColor:noColor});
				}
			}
		}
	}
	
	// weil die Rahmen in umgekehrter Reihenfolge erzeugt worden sind, 
	// knnen wir das Laden der Bilder vorwrts durchfhren
	var cS, rawW, rawH, imgW, imgH, curSize, curRes;
	var oldPc, newPc, pathItems, labelString, curName, curItems, curSuf;
	for (i = 0; i < nFrames; i++) {
		if (fSub == true || bSor == true || cSor == true) {
			curFile = defList[i][0];
		}
		else {
			curFile = defList[i];
		}
		curRect = curDoc.rectangles.item(i);
		try {
			curRect.place(File(curFile));
			cS = curRect.allGraphics[0].geometricBounds;
			rawW = cS[3]-cS[1];
			rawH = cS[2]-cS[0];
			imgW = (Math.floor(((rawW * 1000) + 0.5)))/1000;
			imgH = (Math.floor(((rawH * 1000) + 0.5)))/1000;
			curSize = imgW + " x " + imgH + " mm";
			actRes = -1;
			try {
				var actRes = curRect.allGraphics[0].actualPpi[0];
			}
			catch (e) {
			}
			curRect.label = curFile.fsName.toString();
			// die Anpassen-Optionen zuweisen
			if (fPrp) {
				curRect.fit(FitOptions.PROPORTIONALLY);
				curRect.fit(FitOptions.CENTER_CONTENT);
			}
			if (sPct) {
				// den Inhalt des Rahmens proportional anpassen
				curRect.fit(FitOptions.FILL_PROPORTIONALLY);
				// die Bildgrsse feststellen
				oldPc = curRect.allGraphics[0].horizontalScale;
				// den Wert um 0.5% erhhen und auf eine Nachkommastelle aufrunden
				newPc = Math.ceil((oldPc + 0.5)*10) / 10;
				// den neuen Wert zuweisen
				curRect.allGraphics[0].properties = {horizontalScale:newPc, verticalScale:newPc};
				// das Bild zentrieren
				curRect.fit(FitOptions.CENTER_CONTENT);
			}
			if (fFra) {
				curRect.fit(FitOptions.PROPORTIONALLY);
				curRect.fit(FitOptions.FRAME_TO_CONTENT);
			}
			effRes = -1;
			try {
				var effRes = curRect.allGraphics[0].effectivePpi[0];
			}
			catch (e) {
			}
			// die Bildlegende einfgen, falls gewnscht
			if (rBtn > 0) {
				x1 = curRect.geometricBounds[1];
				y1 = curRect.geometricBounds[2];
				x2 = curRect.geometricBounds[3];
				y2 = curRect.geometricBounds[2]+vOff;
				if (rBtn == 1) {
					labelString = curRect.allGraphics[0].itemLink.name;
					curName = labelString.toLowerCase();
					try {
						curItems = curName.split(".");
						curSuf = curItems[(curItems.length)-1];
						if (actRes != -1) {
							if (sInf && pInf) {
								labelString = labelString + "\n" + curSize + "\noriginal: " + actRes + " ppi / effektiv: " + effRes + " ppi";
							}
							else if (sInf) {
								labelString = labelString + "\n" + curSize;
							}
							else if (pInf) {
								labelString = labelString + "\noriginal: " + actRes + " ppi / effektiv: " + effRes + " ppi";
							}
						}
						else {
							if (sInf) {
								labelString = labelString + "\n" + curSize;
							}
						}
					}
					catch (e) {
					}
				}
				else if (rBtn == 2) {
					labelString = curPath;
				}
				textFrame = curRect.parent.textFrames.add(labelLayer, undefined, undefined,{geometricBounds:[y1, x1, y2, x2], contents:labelString});
				textFrame.textFramePreferences.firstBaselineOffset = FirstBaseline.leadingOffset;
				textFrame.texts[0].appliedParagraphStyle = labelStyle;
			}
		}
		catch (e) {
		}
	}
	// eventuell leergebliebene Rahmen entfernen, falls gewnscht
	if (rEmp == 1) {
		for (var i = curDoc.rectangles.length-1; i >= 0; i--) {
			if (curDoc.rectangles.item(i).contentType == ContentType.unassigned) {
				curDoc.rectangles.item(i).remove();
			}
			else {
				// sobald ein Rahmen mit Inhalt angetroffen wird, die Schleife verlassen
				break;
			}
		}
	}
}